#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[]) {
  int size = 0;
  int *zeta = NULL;
  int j, k;

  if (argc != 2) {
    fprintf(stderr, "USAGE: %s size\n", argv[0]);
    exit(1);
  }

  /* Argument retrieval and check */
  size = atoi(argv[1]);
  if (size < 3) {
    fprintf(stderr, "%s: size must be above 2\n", argv[0]);
    exit(1);
  }

  /* Memory allocation */
  if ((zeta = (int *) calloc(size, sizeof(int))) == NULL) {
    fprintf(stderr, "%s, calloc(%i) failed\n", argv[0], size);
    exit(1);
  }

  /* Inizialization */
  for (j = 0; j < size; j++) {
    zeta[j] = j;
  }

  /* Sieve of Eratosthenes */
  for(j = 2; j < size; j++) {
    if (zeta[j] != 0) {
      k = 2;
      while(k * j < size) {
	zeta[j * k] = 0;
	k++;
      }
    }
  }
  
  /* Results */
  fprintf(stdout, "Primes < %1d\n", size);
  k = 0;
  for (j = 2; j < size; j++) {
    if (zeta[j] != 0) {
      fprintf(stdout, "%1d\n", zeta[j]);
      k++;
    }
  }
  fprintf(stdout, "The number of primes < %1d is %1d\n", size, k);
  free((void *) zeta);

  exit(0);
}
